#include <stdio.h>
#include <unistd.h>  // sleep
#include <emscripten.h>  // emscripten_sleep
#include <string.h>  // strlen

#define LOG_TRACE(_info) do{ LOG_TRACE_Function((char *)_info, (char *)__func__, (int)__LINE__); } while(0)
#ifdef LOG_TRACE
void LOG_TRACE_Function(char *pInfo, char *pFuncName, int LineNum) {
  static int thisCnt = 0; thisCnt++;
  static int FuncNameLenMin = 12; int FuncNameLenCurr = strlen(pFuncName); 
  if(FuncNameLenMin < FuncNameLenCurr) FuncNameLenMin = FuncNameLenCurr;
  printf("[TRACE] (%4d @ %-*s %03d)    %s\n", LineNum, FuncNameLenMin, pFuncName, thisCnt%999, pInfo); fflush(stdout);
}
#endif  // LOG_TRACE

// --------- --------- --------- --------- --------- ---------
#include <pthread.h>
void *pthread_func(void *) { 
  LOG_TRACE("Enter");
  
  for (int index = 0; index < 6; index++) {
    usleep(1000*500);

    LOG_TRACE("beat --> SUB");
  }
  
  LOG_TRACE("Return");
  
  return NULL;
}
void test_pthread_create(void) {
  LOG_TRACE("Enter");
  
  pthread_t thread; 
  pthread_attr_t attr; 
  pthread_attr_init( &attr ); 
  pthread_attr_setdetachstate(&attr,1); 

  pthread_create(&thread, &attr, &pthread_func, NULL);
  
  for (int index = 0; index < 3; index++) {
    usleep(1000*1000);

    LOG_TRACE("beat --> MAIN");
  }
  usleep(1000*1000);
  
  LOG_TRACE("Return");
}


// --------- --------- --------- --------- --------- ---------
#include <thread>
void std_thread_func() { 
  LOG_TRACE("Enter");
  
  for (int index = 0; index < 6; index++) {
    usleep(1000*500);

    LOG_TRACE("beat --> SUB");
  }
  
  LOG_TRACE("Return");
  return ;
}
void test_std_thread(void) {
  LOG_TRACE("Enter");
  
  std::thread thread_handle(std_thread_func);
  
  for (int index = 0; index < 3; index++) {
    usleep(1000*1000);

    LOG_TRACE("beat --> MAIN");
  }
  usleep(1000*1000);

  LOG_TRACE("want to call join");
  thread_handle.join();

  LOG_TRACE("Return");
}


// --------- --------- --------- --------- --------- ---------
void test_thread(void) {

  LOG_TRACE("Enter");

  test_pthread_create();

  test_std_thread();

  LOG_TRACE("Return");
}


// --------- --------- --------- --------- --------- ---------
#include <emscripten/bind.h>
using namespace emscripten;
EMSCRIPTEN_BINDINGS(module01) {
  LOG_TRACE("Enter");
	
  function("test_thread", &test_thread);

  LOG_TRACE("Return");
}


#if 1
// --------- --------- --------- --------- --------- ---------
int main() {
  LOG_TRACE("Enter");

  test_thread();

  LOG_TRACE("Return");
  
  return 0;
}
#endif
